//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class Discrete1DFunction : TabulatedFunction {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal Discrete1DFunction(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.Discrete1DFunction_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(Discrete1DFunction obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~Discrete1DFunction() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_Discrete1DFunction(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public Discrete1DFunction(SWIGTYPE_p_std__vectorT_double_t values) : this(OpenMMSwigPINVOKE.new_Discrete1DFunction(SWIGTYPE_p_std__vectorT_double_t.getCPtr(values)), true) {
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void getFunctionParameters(SWIGTYPE_p_std__vectorT_double_t values) {
    OpenMMSwigPINVOKE.Discrete1DFunction_getFunctionParameters(swigCPtr, SWIGTYPE_p_std__vectorT_double_t.getCPtr(values));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setFunctionParameters(SWIGTYPE_p_std__vectorT_double_t values) {
    OpenMMSwigPINVOKE.Discrete1DFunction_setFunctionParameters(swigCPtr, SWIGTYPE_p_std__vectorT_double_t.getCPtr(values));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public override TabulatedFunction Copy() {
    global::System.IntPtr cPtr = OpenMMSwigPINVOKE.Discrete1DFunction_Copy(swigCPtr);
    Discrete1DFunction ret = (cPtr == global::System.IntPtr.Zero) ? null : new Discrete1DFunction(cPtr, false);
    return ret;
  }

}

}
